#include "main.h"
#include "calc.h"
#include "init.h"
#include "draw.h"
#include "hud.h"
#include "highscore.h"

int drawGLScene(ASTEROID *asteroids, SHIP *ships, BULLET *bullets){

    char print_buf[128];
	
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

    glLoadIdentity();

    glRotatef(ships->xrot,1.0f,0.0f,0.0f);
    glRotatef(ships->yrot,0.0f,1.0f,0.0f);

    glTranslatef(-ships->px,-ships->py,-ships->pz);

    
    draw_sky_box();
    draw_asteroids(asteroids);
    draw_bullets(bullets,ships);

    goto_ortho();
    	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND); 
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glBindTexture(GL_TEXTURE_2D,  texture[9]);
	glBegin(GL_QUADS);
        	glTexCoord2f(0.0f, 1.0f);    glVertex2f(430, 270);
        	glTexCoord2f(0.0f, 0.0f);    glVertex2f(430, 330);
        	glTexCoord2f(1.0f, 0.0f);    glVertex2f(370, 330);
        	glTexCoord2f(1.0f, 1.0f);    glVertex2f(370, 270);
    	glEnd(); 
	
	sprintf(print_buf,"Asteroids destroyed: %i/63  Fuel %i",kills,(int)ships->fuel);
	print_font(print_buf,10,580,0,1,0);

	if(alert){
		print_font("Warning! Proximity Alert!",300,450,1,0,0);
		alert=0;
	}
	
	if((ships->fuel<30)&&(ships->fuel>10))print_font("Warning! Fuel is Low",300,400,1,0,0);
	if(ships->fuel<10)print_font("WARNING, FUEL IS CRITICAL!",300,400,1,0,0);
	if(!finished)print_font("WELL DONE! YOU SAVED THE EARTH!",300,400,1,1,1);

	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
    exit_ortho();

    ships->fuel-=calculate_timing();

    SDL_GL_SwapBuffers();

    
	
	
    return(TRUE);
}


void draw_fuel(){
	glCallList(260);
}


void draw_sky_box(){
	glCallList(258);
}

void draw_asteroids(ASTEROID *asteroids){

	int i;
	GLfloat ax,ay,az,s=15;
	for(i=0;i<MAX_ASTEROIDS;i++){
		if(asteroids->state==0){
			asteroids++;
			continue;
		}
		ax=asteroids->px;
		ay=asteroids->py;
		az=asteroids->pz;
 		s=5*(GLfloat)asteroids->state;
		glMatrixMode(GL_MODELVIEW);    
		glPushMatrix();
		glTranslatef(ax,ay,az);
		glScalef(s,s,s);
		glRotatef(-asteroids->yrot,0.0f,1.0f,0.0f);
		glRotatef(-asteroids->xrot,1.0f,0.0f,0.0f);
		glRotatef(-asteroids->zrot,0.0f,0.0f,1.0f);
		if(asteroids->state!=4){glCallList(257);}
		if(asteroids->state==4){draw_fuel();}
		glPopMatrix();
		asteroids++;
	}
}

void draw_bullets(BULLET *bullets, SHIP *ships){

	int i;
	GLfloat ax,ay,az;
	for(i=0;i<128;i++){
		if(bullets->state==0){
			bullets++;
			continue;
		}
		ax=bullets->px;
		ay=bullets->py;
		az=bullets->pz;	
		bullets++;

	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND); 
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glMatrixMode(GL_MODELVIEW);    
	glPushMatrix();
	glTranslatef(ax,ay,az);

        glRotatef(-ships->yrot,0.0f,1.0f,0.0f);
	glRotatef(-ships->xrot,1.0f,0.0f,0.0f);

	glCallList(259);
	
	glPopMatrix();
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
	}
}

int playsound(Mix_Chunk *sound, int soundChannel){
	Mix_VolumeChunk(sound,volume);
	if(soundChannel>0){
		Mix_HaltChannel(soundChannel);
		Mix_PlayChannel(soundChannel,sound,0);		
	}
	else{
		soundChannel=Mix_PlayChannel(-1,sound,0);
	}
	return soundChannel;
}

