#include "main.h"
#include "calc.h"
#include "init.h"
#include "draw.h"
#include "hud.h"
#include "highscore.h"

void create_highscore_file(){
	int i;
	char buf[32];
	FILE *ptr_highscore_file;

	if(!(ptr_highscore_file=fopen(".highscore","r"))){
		fprintf(stderr,"Cant find highscore file... Creating one\n");
		if(!(ptr_highscore_file=fopen(".highscore","w+"))){
			fprintf(stderr,"Unable to create default highscore file\n");
			return;
		}
		for(i=0;i<10;i++){ 
			sprintf(buf,"%i\n",10-i);  
			fputs(buf,ptr_highscore_file); 
			fputs("blud0t\n",ptr_highscore_file);
		}

	}
	fclose(ptr_highscore_file);
}

int write_to_highescore_file(){
	int i,insert=1;
	char buf[32];
	struct table_element table[11], *head_ptr=&(table[0]), *tableptr;	
	FILE *ptr_highscore_file;

	if(!(ptr_highscore_file=fopen(".highscore","r+"))){
			fprintf(stderr,"Unable to open highscore file for writing...\n");
			return(0);
	}

	table[10].score=kills;
	strncpy(table[10].name,name,11);

	for(i=0;i<10;i++){
		table[i].score=atoi(fgets(buf,32,ptr_highscore_file));
		strncpy(table[i].name,fgets(buf,16,ptr_highscore_file),16);
		table[i].name[strlen(table[i].name)-1]=0x00;

		if((kills>table[i].score)&&(insert)){
			insert=0;
			if(i>0){
				table[i-1].next=&(table[10]);
				table[10].next=&(table[i]);
			}
			else{
				head_ptr=&(table[10]);
				table[10].next=&(table[0]);
			}
		}
		table[i].next=&(table[i+1]);
	}
	tableptr=head_ptr;
	rewind(ptr_highscore_file);
	for(i=1;i<11;i++){
		sprintf(buf,"%i\n",tableptr->score);  
		fputs(buf,ptr_highscore_file);
		sprintf(buf,"%s\n",tableptr->name);  
		fputs(buf,ptr_highscore_file);
		tableptr=tableptr->next;

	}		
	fclose(ptr_highscore_file);
	return(1);
}

int display_highscore_file(){
	int i;
	char buf[32];
	FILE *ptr_highscore_file;

	if(!(ptr_highscore_file=fopen(".highscore","r"))){
			fprintf(stderr,"Unable to open highscore file for reading\n");
			return(0);
	}

	print_font("HALL OF FAME",370,550,0.2,1,0.2);
	
	for(i=1;i<11;i++){
		sprintf(buf,"%i. %i",i, atoi(fgets(buf,32,ptr_highscore_file)));
		print_font(buf,250,500-i*20,0.2,1,0.2);

		sprintf(buf,"%s",fgets(buf,16,ptr_highscore_file));
		print_font(buf,550,500-i*20,0.2,1,0.2);

	}
	fclose(ptr_highscore_file);
	return(1);
}

