#include "main.h"
#include "init.h"
#include "draw.h"
#include "calc.h"
#include "hud.h"
#include "highscore.h"


int main(int argc,char **argv){

	int done=0 ;
	unsigned char key=0, buf[32];
    	SDL_Event event;
    	ASTEROID asteroids[86];
    	SHIP ships[1];
    	BULLET bullets[128];

	ts=0;
	n=0;
	audio=0;
	volume=30;

	strncpy(name,getenv("USER"),64);
	if(argc==2)strncpy(name,argv[1],64);

	fprintf(stderr,"\n-=+* GLAsteroids v0.9 - Blud0t of Project Z - http://projectz.ath.cx *+=-\n\n");

	SDL_init();
    	initGL();

    	resizeWindow(SCREEN_WIDTH, SCREEN_HEIGHT);
    	init_objects(asteroids,ships,bullets);	
	load_audio_and_textures();
	create_highscore_file();

    	while(!done){
		while(SDL_PollEvent(&event)){
			switch(event.type){

			case SDL_VIDEORESIZE:
				surface = SDL_SetVideoMode( event.resize.w,event.resize.h,16,videoFlags );
				if(!surface){
					fprintf(stderr,"Could not get a surface after resize...\n");
					Quit(1);
				}
				resizeWindow( event.resize.w, event.resize.h );
			break;

			case SDL_KEYDOWN:
			    key=handleKeyPress(&event.key.keysym,SDL_KEYDOWN);
			break;

			case SDL_KEYUP:
				handleKeyPress(&event.key.keysym,SDL_KEYUP);
   	            break;
		
			case SDL_MOUSEMOTION:
				ships[0].xrot+=((GLfloat)event.motion.yrel)/5;
 				ships[0].yrot+=((GLfloat)event.motion.xrel)/5;		
			break;
	
			case SDL_MOUSEBUTTONDOWN:
				mb1=1;
			break;

			case SDL_MOUSEBUTTONUP:
				mb1=0;
			break;
			
			case SDL_QUIT:
			    done=1;
				write_to_highescore_file();
			break;

			default:
			    break;
			}
		}

	if(menu){
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

		glLoadIdentity();
		SDL_ShowCursor(1);
		SDL_WM_GrabInput(SDL_GRAB_OFF);

		goto_ortho();
		glDisable(GL_DEPTH_TEST);
		glEnable(GL_BLEND); 
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		
		if(menu==1){

		glBindTexture(GL_TEXTURE_2D,  texture[2]);
		glBegin(GL_QUADS);
        		glTexCoord2f(1.0f, 1.0f);    glVertex2f(580, 520);
        		glTexCoord2f(1.0f, 0.0f);    glVertex2f(580, 580);
        		glTexCoord2f(0.0f, 0.0f);    glVertex2f(220, 580);
        		glTexCoord2f(0.0f, 1.0f);    glVertex2f(220, 520);
    		glEnd(); 
		glBindTexture(GL_TEXTURE_2D,  texture[4]);
		glBegin(GL_QUADS);
        		glTexCoord2f(1.0f, 1.0f);    glVertex2f(600, 420);
        		glTexCoord2f(1.0f, 0.0f);    glVertex2f(600, 480);
        		glTexCoord2f(0.0f, 0.0f);    glVertex2f(220, 480);
        		glTexCoord2f(0.0f, 1.0f);    glVertex2f(220, 420);
    		glEnd();

		print_font("Presents...",370,500,0,1,0);

		if((event.motion.x<430)&&(event.motion.x>370)
		&&(event.motion.y>235)&&(event.motion.y<250)){
			print_font("NEW GAME...",370,350,0.2,1,0.2);
			if(mb1==1){
				init_objects(asteroids,ships,bullets);
				menu=0;
				mb1=0;
				SDL_WM_GrabInput(SDL_GRAB_ON);
			}
			
		}
		else{print_font("NEW GAME...",370,350,0.23,0.6,0.23);}
	
		if((event.motion.x<450)&&(event.motion.x>370)
		&&(event.motion.y>260)&&(event.motion.y<275)){
			print_font("HALL OF FAME",370,325,0.2,1,0.2);
			if(mb1==1){
				menu=2;
				mb1=0;
		
			}
		}
		else{print_font("HALL OF FAME",370,325,0.23,0.6,0.23);}

		if((event.motion.x<430)&&(event.motion.x>370)
		&&(event.motion.y>285)&&(event.motion.y<300)){
			print_font("SETUP",370,300,0.2,1,0.2);
			if(mb1==1){
				menu=3;
				mb1=0;
			}
		}
		else{print_font("SETUP",370,300,0.23,0.6,0.23);}

		

		if((event.motion.x<430)&&(event.motion.x>370)
		&&(event.motion.y>310)&&(event.motion.y<325)){
			print_font("QUIT",370,275,0.2,1,0.2);
			if(mb1==1){
				Quit(0);
			}
		}
		else{print_font("QUIT",370,275,0.23,0.6,0.23);}

		}

		print_font("v0.9: Coded by blud0t - http://projectz.ath.cx",235,120,0.2,0.6,0.2);

		if(menu==2){
			if((mb1==1)||(!display_highscore_file()))menu=1;
			mb1=0;
		}

		if(menu==3){
			if(key==0x08){
				if(strlen(name)>0)name[strlen(name)-1]=0x00;
		 	}
			else{
				if(strlen(name)<16){
					name[strlen(name)+1]=0x00;
					name[strlen(name)]=key;
				}
			}
			
			sprintf(buf,"Name: %s", name);
			print_font(buf,370,350,0.23,0.6,0.23);
			key=0;
			
			if(audio){sprintf(buf,"Audio: ON");}
			else{sprintf(buf,"Audio: OFF");}

			if((event.motion.x<430)&&(event.motion.x>370)
			&&(event.motion.y>260)&&(event.motion.y<275)){
				print_font(buf,370,325,0.2,1,0.2);
				if(mb1==1){
					if(audio){audio=0;}
					else{audio=1;}
					mb1=0;
				}
			}
			else{print_font(buf,370,325,0.23,0.6,0.23);}			

		   sprintf(buf,"Volume: %i", volume);

			if((event.motion.x<430)&&(event.motion.x>370)
			&&(event.motion.y>285)&&(event.motion.y<300)){
				print_font(buf,370,300,0.2,1,0.2);
				if(mb1==1){
					volume++;
					if(volume>=MIX_MAX_VOLUME)volume=0;
				}
			}
			else{print_font(buf,370,300,0.23,0.6,0.23);}	


			if((event.motion.x<430)&&(event.motion.x>370)
			&&(event.motion.y>310)&&(event.motion.y<325)){
				print_font("DONE",370,275,0.2,1,0.2);
				if(mb1==1){
					menu=1;
					mb1=0;
				}
			}
			else{print_font("DONE",370,275,0.23,0.6,0.23);}
		}

		glDisable(GL_BLEND);
		glEnable(GL_DEPTH_TEST);
		exit_ortho();

		calculate_timing();
		SDL_GL_SwapBuffers();
	}
	else{
		SDL_ShowCursor(0);
		if(!finished&&mb1==1){
			write_to_highescore_file();
			menu=2;
			mb1=0;
		}
		if(finished)updatescene(asteroids,ships,bullets);
		collidetect(asteroids,ships,bullets);
		drawGLScene(asteroids,ships,bullets);
		reload+=0.1;
	}
    }
    Quit(0);
    return(0);

}
