#ifndef _MAIN_H_
#define _MAIN_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"

#define SCREEN_WIDTH  800
#define SCREEN_HEIGHT 600
#define SCREEN_BPP     24

#define TRUE  1
#define FALSE 0
#define NUM_TEXTURES 13
#define DEGTORAD 0.01745329
#define FRM_RTE 65
#define DATA_DIR "./textures"
#define NUM_NEW 4
#define MAX_ASTEROIDS 85

typedef struct{ 
 GLfloat vx,vy,vz;
 GLfloat px,py,pz;
 GLfloat vxrot, vyrot, vzrot;
 GLfloat xrot, yrot, zrot;
 int state, hits, prox;
}ASTEROID;

typedef struct{
 GLfloat xrot,yrot;
 GLfloat vx,vy,vz,vxz;
 GLfloat px,py,pz;
 GLfloat fuel;
 int state;
}SHIP;

typedef struct{
 GLfloat vx,vy,vz,vxz;
 GLfloat px,py,pz;
 int state;
 int range;
}BULLET;

typedef struct{
 GLfloat x,y,z;
}VECTOR;

/*Various variables that needed to be global*/

int a,s,d,w,space;  /*these keep track of which keys are held down*/
int mb1,delay,n,audio,finished;
int fontlist,kills,menu,volume;  /*other stuff*/
int videoFlags,alert,refuel;
int plasmaChannel,proxalertChannel,explChannel;

char name[16]; /*player name*/

VECTOR vertices [5][4];

GLfloat timevar,reload;

/*timing variable*/

GLfloat ts;

SDL_Surface *surface;
Mix_Chunk *plasma,*proxalert,*explo;
GLuint texture[NUM_TEXTURES];

#endif
